/*
 * Copyright (C) 2019  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#include "Bsp/SystemTime.h"
#include "Bsp/Drivers/LowPower.h"
#include "Bsp/macros.h"

#include "stm32l0xx.h"

uint32_t wakeups = 0;

namespace BSP {

using BSP::ReturnCode;

ReturnCode LowPower::init()
{
    enable_debug();
    return ReturnCode::OK;
}

ReturnCode LowPower::enable_debug()
{
    /* Enable Clocks */
    // SET(RCC->APB2ENR, RCC_APB2ENR_DBGEN);
    // SET(RCC->APB2SMENR, RCC_APB2SMENR_DBGSMEN);

    // SET(DBGMCU->CR, DBGMCU_CR_DBG_STOP);
    // SET(DBGMCU->CR, DBGMCU_CR_DBG_SLEEP);
    // SET(DBGMCU->CR, DBGMCU_CR_DBG_STANDBY);

    return ReturnCode::OK;
}

ReturnCode LowPower::disable_debug()
{
    CLR(DBGMCU->CR, DBGMCU_CR_DBG_STOP);
    CLR(DBGMCU->CR, DBGMCU_CR_DBG_SLEEP);
    CLR(DBGMCU->CR, DBGMCU_CR_DBG_STANDBY);

    CLR(RCC->APB2SMENR, RCC_APB2SMENR_DBGSMEN);

    return ReturnCode::OK;
}

ReturnCode LowPower::sleep()
{
    // TODO: unimplemented

    return ReturnCode::FAIL;
}

ReturnCode LowPower::stop()
{
    SET(PWR->CR, PWR_CR_CWUF); // clear wakeup flag
    while(PWR->CSR & PWR_CSR_WUF) {};

    CLR(PWR->CR, PWR_CR_PDDS); // Enter stop mode when the CPU enters deepsleep
    CLR(RCC->CFGR, RCC_CFGR_STOPWUCK); // MSI oscillator is wake-up from stop clock
    SET(SCB->SCR, SCB_SCR_SLEEPDEEP_Msk); // low-power mode = stop mode
    __WFI(); // enter low-power mode (Wake from interrupt)

    wakeups++;

    return ReturnCode::OK;
}

}
